'use strict';
const emojiRegex = /\uD83D\uDC69\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D(?:\uD83D\uDC69\u200D)?\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D(?:\uD83D\uDC69\u200D)?\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92])|\uD83D\uDC68(?:\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC66\u200D\uD83D\uDC66|\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68)|(?:\uD83C[\uDFFB-\uDFFF])\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]))|(?:\uD83D\uDC69\u200D[\u2695\u2696\u2708]|\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2695\u2696\u2708]|\uD83D\uDC68(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708]))\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC6F\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3C-\uDD3E\uDDD6-\uDDDF])\u200D[\u2640\u2642]\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]\uFE0F|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uFE0F\u200D[\u2640\u2642])\uFE0F|(?:[\u261D\u270A-\u270D]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC70\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDCAA\uDD74\uDD7A\uDD90\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD36\uDDD1-\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF4\uD83C\uDDF2|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|\uD83D\uDC68(?:\u200D(?:(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC67|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC66)|\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69(?:\u200D(?:(?:\uD83D\uDC69\u200D)?\uD83D\uDC67|(?:\uD83D\uDC69\u200D)?\uD83D\uDC66)|\uD83C[\uDFFB-\uDFFF])|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])|[#\*0-9]\uFE0F\u20E3|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC69\uDC6E\uDC70-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD18-\uDD1C\uDD1E\uDD1F\uDD26\uDD30-\uDD39\uDD3D\uDD3E\uDDD1-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])?|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDEEB\uDEEC\uDEF4-\uDEF8]|\uD83E[\uDD10-\uDD3A\uDD3C-\uDD3E\uDD40-\uDD45\uDD47-\uDD4C\uDD50-\uDD6B\uDD80-\uDD97\uDDC0\uDDD0-\uDDE6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u2660\u2663\u2665\u2666\u2668\u267B\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEF8]|\uD83E[\uDD10-\uDD3A\uDD3C-\uDD3E\uDD40-\uDD45\uDD47-\uDD4C\uDD50-\uDD6B\uDD80-\uDD97\uDDC0\uDDD0-\uDDE6])\uFE0F/g;

var i18n = {
    'default': {
        'context': {
            'image': 'Save Image to Eagle(&Z)',
            'video': 'Save Video to Eagle(&Z)',
        }
    },
    'ja': {
        'context': {
            'image': '画像を Eagle に保存(&Z)',
            'video': '映像を Eagle に保存(&Z)',
        }
    },
    'zh-TW': {
        'context': {
            'image': '將圖片保存至 Eagle(&Z)',
            'video': '將影片保存至 Eagle(&Z)',
        }
    },
    'zh-CN': {
        'context': {
            'image': '将图片保存至 Eagle(&Z)',
            'video': '将视频保存至 Eagle(&Z)',
        }
    },
};

var i18n_words = i18n['default'];
var language = window.navigator.language;
if (language === 'zh') {
    language = 'zh-CN';
}
if (i18n[language]) {
    i18n_words = i18n[language];
}

chrome.contextMenus.create({
    contexts: ["all"],
    id: 'background_img',
    title: i18n_words.context['image']
});

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    if (request.message == 'updateContextMenu') {
        if (request.type === "video") {
            chrome.contextMenus.update('background_img', {
                visible: true,
                contexts: ["all"],
                title: i18n_words.context['video']
            });
        } 
        else if (request.type === "image") {
            chrome.contextMenus.update('background_img', {
                visible: true,
                contexts: ["all"],
                title: i18n_words.context['image']
            });
        }
        else {
            chrome.contextMenus.update('background_img', {
                visible: false,
                contexts: ["all"],
                title: i18n_words.context['image']
            });
        }
    }
    if (request.action === "screencapture") {
        var pixelRatio = request.pixelRatio || 1;
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            var tab = tabs[0];
            currentTab = tab; // used in later calls to get tab info
            var filename = getFilename(tab.url);
            webCapture(tab, filename, finishCaptures, errorHandler, pixelRatio);
        });
    }
    // 截取当前画面
    else if (request.action === "capture-visible") {

        var pixelRatio = request.pixelRatio || 1;
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            var tab = tabs[0];
            currentTab = tab;
            var id = (tabs[0] && tabs[0].id) || currentTab.id;
            var format = localStorage.getItem("captureFormat") || 'png';

            chrome.tabs.executeScript(currentTab.id, {
                code : `document.getElementsByTagName("html")[0].classList.add("eagle-cropper-opened")`
            });

            setTimeout(function () {
                chrome.tabs.captureVisibleTab(null, {format: format, quality: 100}, function(dataURI) {
                    chrome.tabs.executeScript(currentTab.id, {
                        code : `document.getElementsByTagName("html")[0].classList.remove("eagle-cropper-opened")`
                    });
                    if (dataURI) {
                        if (pixelRatio > 1 && !useRetina) {
                            var image = new Image();
                            image.onload = function() {
                                var canvas = document.createElement('canvas');
                                canvas.width = image.width;
                                canvas.height = image.height;
                                var ctx = canvas.getContext('2d');
                                ctx.drawImage(
                                    image,
                                    0,
                                    0
                                );
                                canvas = resizeCanvas(canvas, pixelRatio);
                                var base64String;
                                if (format === "png") {
                                    base64String = canvas.toDataURL();
                                }
                                else {
                                    base64String = canvas.toDataURL("image/jpeg", 1);
                                }
                                finishCaptures(base64String);
                            };
                            image.src = dataURI;
                        }
                        else {
                            finishCaptures(dataURI);
                        }
                    }
                });
            }, 200);
        });
    }
    else if (request.action === "batch-save") {
        chrome.tabs.executeScript(null, { file: "getPagesSource.js" });
    }
    else if (request.action === "change-retina") {
        useRetina = request.useRetina || false;
    }
    return true;
});

var currentTab, // result of chrome.tabs.query of current active tab
    resultWindowId; // window id for putting resulting images
var isBackground = true;
var captureFormat = 'png';
var useRetina = false;

captureFormat = localStorage.getItem("captureFormat") || 'png';
chrome.storage.sync.get(['captureFormat'], function(result) {
    if (result.captureFormat === undefined) {
        captureFormat = 'png';
    }
    else {
        captureFormat = result.captureFormat;
    }
});

useRetina = localStorage.getItem("useRetina") === 'true';

function getFilename(contentURL) {
    var name = contentURL.split('?')[0].split('#')[0];
    if (name) {
        name = name
            .replace(/^https?:\/\//, '')
            .replace(/[^A-z0-9]+/g, '-')
            .replace(/-+/g, '-')
            .replace(/^[_\-]+/, '')
            .replace(/[_\-]+$/, '');
        name = '-' + name;
    } else {
        name = '';
    }
    return 'screencapture' + name + '-' + Date.now() + '.png';
}

function finishCaptures(base64String, index) {

    var indexStr = "";
    if (index) {
        indexStr = " #" + index
    }

    chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
        window.jQuery.ajax({
            type:"POST",
            url: "http://localhost:41593",
            // dataType: "json",
            data: {
                type: "screen capture",
                title: currentTab.title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, '') + indexStr,
                url: currentTab.url,
                base64: base64String,
            },
            success: function(result){
                
                // setTimeout(function () {
                //     window.close();
                // }, 500);
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
            else {
                // chrome.tabs.executeScript(currentTab.id, {
                //     code : `
                //         if(document.getElementById('intercom-container')) document.getElementById('intercom-container').style.visibility = 'initial';
                //         if(document.getElementById('gorgias-web-messenger-container')) document.getElementById('gorgias-web-messenger-container').style.visibility = 'initial';
                //         if(document.getElementById('beacon-container')) document.getElementById('beacon-container').style.visibility = 'initial';
                //         if(document.getElementById('chat-widget-container')) document.getElementById('chat-widget-container').style.visibility = 'initial';
                //         if(document.getElementById('drift-widget')) document.getElementById('drift-widget').style.visibility = 'initial';
                //         if(document.getElementById('fc_widget')) document.getElementById('fc_widget').style.visibility = 'initial';
                //         if(document.getElementById('crisp-chatbox')) document.getElementById('crisp-chatbox').style.opacity = '';
                //         if(document.querySelector(".qa-project-user-actions")) document.querySelector(".qa-project-user-actions").style.visibility = 'initial';
                //         if(document.querySelector(".Project-stickyAppreciateContainer-neq")) document.querySelector(".Project-stickyAppreciateContainer-neq").style.visibility = 'initial';
                //         if(document.querySelector(".rocketchat-widget")) document.querySelector(".rocketchat-widget").style.visibility = 'initial';
                //         if(document.querySelector(".tb-toolbar")) document.querySelector(".tb-toolbar").style.visibility = 'initial';
                //         if(document.querySelector(".mui-mbar-tabs-mask")) document.querySelector(".mui-mbar-tabs-mask").style.visibility = 'initial';
                //         if(document.querySelector('.tshop-psm-shop-ww-hover')) document.querySelector('.tshop-psm-shop-ww-hover').style.visibility = 'initial';
                //         if(document.querySelector('.mui-mbar-outer')) document.querySelector('.mui-mbar-outer').style.visibility = 'initial';
                //         if(document.querySelector('.zEWidget-launcher')) document.querySelector('.zEWidget-launcher').style.visibility = 'initial';
                //         if(document.querySelector('.is-offset-fixed-wrap')) document.querySelector('.is-offset-fixed-wrap').style.visibility = 'initial';
                //         if(document.querySelector('.sidebar-fixed-wrapper')) document.querySelector('.sidebar-fixed-wrapper').style.visibility = 'initial';
                //         if(document.querySelector('.rf-footer--infinity')) document.querySelector('.rf-footer--infinity').style.visibility = 'initial';
                //         `
                // });
                // chrome.tabs.executeScript(currentTab.id, {
                //     code : "if(document.getElementById('drift-widget')) document.getElementById('drift-widget').style.visibility = 'initial'"
                // });
                // chrome.tabs.executeScript(currentTab.id, {
                //     code : `
                //         if (document.getElementsByClassName('zopim')[0] && document.getElementsByClassName('zopim')[0].length > 0)
                //             document.getElementsByClassName('zopim')[0].style.visibility = 'initial';
                //         if (document.getElementsByClassName('js-social-sharing-sticky')[0] && document.getElementsByClassName('js-social-sharing-sticky')[0].length > 0)
                //             document.getElementsByClassName('js-social-sharing-sticky')[0].style.visibility = 'initial';
                //     `
                // });
                // chrome.tabs.executeScript(currentTab.id, {
                //     code : `
                //         var elems = document.body.getElementsByTagName('*');
                //         var len = elems.length;
                //         for (var i=0;i<len;i++) {
                //             if (elems[i].className.indexOf && elems[i].className.indexOf('eagle-hidden') !== -1) {
                //                 elems[i].className.replace('eagle-hidden', '');
                //                 elems[i].style.position = 'fixed';
                //                 // elems[i].style.visibility = 'initial';
                //             }
                //         }`
                // });
                chrome.tabs.sendMessage(currentTab.id, { action: "close-crop-area" }, function(response) {});
            }
        });
    });
}

function errorHandler(reason) {}

chrome.commands.onCommand.addListener(function(command) {
    switch (command) {
        case "quick-save":
            chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
                chrome.tabs.sendMessage(tabs[0].id, { action: "quick-save" }, function(response) {});
            });
            break;
        case "save-images":
            chrome.tabs.executeScript(null, { file: "getPagesSource.js" });
            break;
        case "capture-entire-beta":
            openWebCapture();
            break;
        case "capture-selected":
            openSceenshot();
            break;
    }
});

function openWebCapture () {
    chrome.tabs.query({active: true}, function(tabs){
        window.jQuery.ajax({
            method:"POST",
            url: "http://localhost:41593",
            // dataType: "json",
            data: {
                type: "capture-website",
                title: currentTab.title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
                url: currentTab.url,
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
        })
    });
}

function openSceenshot () {
    chrome.tabs.query({active: true}, function(tabs){
        window.jQuery.ajax({
            method:"POST",
            url: "http://localhost:41593",
            // dataType: "json",
            data: {
                type: "screenshot",
                title: currentTab.title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
                url: currentTab.url,
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
        })
    });
}

chrome.contextMenus.onClicked.addListener(function onContextMenu(info, tab) {
    chrome.tabs.sendMessage(tab.id, '', function onMessageResponse(msg) {
    // console.time("取得图片 base64 - ");
        if (!msg || !msg.src) return;
        msg.src = convertSrc(msg.src);
        toDataURL(msg.src, function(base64) {
            // console.timeEnd("取得图片 base64 - ");
            var result = base64 || msg.src;
            window.jQuery.ajax({
                type: "POST",
                url: "http://localhost:41593",
                // dataType: "json",
                timeout: 3000,
                data: {
                    type: "image",
                    title: msg.title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
                    url: msg.link || tab.url,
                    src: result,
                    metaAlt: msg.metaAlt,
                    metaTitle: msg.metaTitle,
                    metaDescription: msg.metaDescription,
                    metaKeywords: msg.metaKeywords,
                    metaTags: msg.metaTags,
                    // forceOpenCollectModal: msg.forceOpenCollectModals
                }
            }).always(function(result) {
                if (result.status == 0) {
                    openEagle();
                }
            })
        });
    });
});

chrome.runtime.onMessage.addListener(function(msg, sender, sendResponse) {
    if (msg.action == "getSource") {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            var images = JSON.parse(msg.source);
            images.forEach(function (image) {
                if (!image.title) {
                    image.title = tabs[0].title;
                }

                // 有些网址可能是 "url 1.5x" 这样的格式，需避免
                if (image.src && image.src.indexOf(" ") > -1) {
                    image.src = image.src.trim().split(" ")[0];
                }
                
                if (image.src !== convertSrc(image.src)) {
                    image.urlConverted = true;
                    image.src = convertSrc(image.src) || image.src;    
                }

                image.title = image.title.replace(emojiRegex, '').replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, '');
            });
            window.jQuery.ajax({
                method:"POST",
                url: "http://localhost:41593",
                // dataType: "json",
                data: {
                    type: "import-images",
                    title: tabs[0].title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
                    url: tabs[0].url,
                    images: JSON.stringify(images),
                }
            }).always(function (result) {
                if (result.status == 0) {
                    openEagle();
                }
            })
        });
    }
    else if (msg.src) {
        chrome.tabs.query({ active: true, currentWindow: true }, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, '', function onMessageResponse(src) {
                // console.time("取得图片 base64");
                msg.src = convertSrc(msg.src);
                if (!msg.src) return;
                toDataURL(msg.src, function(base64) {
                    // console.timeEnd("取得图片 base64");
                    var result = base64 || msg.src;
                    window.jQuery.ajax({
                        type: "POST",
                        url: "http://localhost:41593",
                        // dataType: "json",
                        timeout: 3000,
                        data: {
                            type: "image",
                            title: msg.title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
                            url: msg.link || tabs[0].url,
                            src: result,
                            metaAlt: msg.metaAlt,
                            metaTitle: msg.metaTitle,
                            metaDescription: msg.metaDescription,
                            metaKeywords: msg.metaKeywords,
                            metaTags: msg.metaTags,
                            forceOpenCollectModal: msg.forceOpenCollectModal
                        }
                    }).always(function(result) {
                        if (result.status == 0) {
                            openEagle();
                        }
                    })
                });
            });
        });
    }
    return true;
});

function toDataURL(url, callback) {
    var xhr = new XMLHttpRequest();
    var timeout;
    var sent = false;
    var isVideo = url.toLowerCase().indexOf(".mp4") > -1 || url.toLowerCase().indexOf(".webm") > -1;
    var isGIF = url.toLowerCase().indexOf(".gif") > -1;
    if (isVideo || isGIF) {
        callback(undefined);
        return;
    }
    // console.log(url);
    xhr.onload = function() {
        clearTimeout(timeout);
        var reader = new FileReader();
        reader.onloadend = function() {
            if (!sent) {
                sent = true;
                if (reader.result.indexOf("data:image") > -1) {
                    callback(reader.result);
                }
                else {
                    callback(undefined);
                }
            }
        }
        reader.readAsDataURL(xhr.response);
    };
    xhr.open('GET', url);
    xhr.responseType = 'blob';
    xhr.send();

    timeout = setTimeout(function () {
        if (!sent) {
            sent = true;
            callback(undefined);
        }
    }, 500);
}

function openEagle () {
    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
        chrome.tabs.sendMessage(tabs[0].id, { action: "open-not-opened-modal" }, function(response) {});
    });
};

// 使用 imagus 提供的转大图功能
var sieveURL = chrome.runtime.getURL("sieve.json");
var remoteSieveURL = "https://eagle-1253434826.cosgz.myqcloud.com/extensions/sieve.json";
var cacheRules = {};
var cacheRulesJSON = localStorage.getItem("cacheRules");
try {
    if (cacheRulesJSON) {
        cacheRules = JSON.parse(cacheRulesJSON);
    }
}
catch (err) {

}

// 检查规则是否更新（每小时一次）
checkRuleUpdates();

// var alarmInfo = {
//     delayInMinutes: 1,
//     periodInMinutes: 180
// };

// chrome.alarms.clearAll();
// chrome.alarms.onAlarm.addListener(function (alarm) {
//     checkRuleUpdates();
// });
// chrome.alarms.create('updateRules', alarmInfo);

function checkRuleUpdates() {
    console.log("檢查規則文件是否有更新")
    fetch(sieveURL)
        .then((response) => response.json()) //assuming file contains json
        .then(function (localData) {

            if (localData && localData.version) {

                // 扩展更新规则改变时，将本地缓存更新
                if (cacheRules && cacheRules.version && cacheRules.version < localData.version) {
                    cacheRules = localData;
                    localStorage.setItem("cacheRules", JSON.stringify(cacheRules));
                }
                else if (!cacheRules || !cacheRules.version) {
                    cacheRules = localData;
                    localStorage.setItem("cacheRules", JSON.stringify(localData));
                }

                // 检查远程规则，如果有调整，就更新
                fetch(remoteSieveURL)
                    .then((response) => response.json())
                    .then(function (data) {
                        if (data && data.version) {
                            if (cacheRules && cacheRules.version < data.version) {
                                if (cacheRules && cacheRules.version && cacheRules.version < data.version) {
                                    cacheRules = data;
                                    localStorage.setItem("cacheRules", JSON.stringify(cacheRules));
                                }
                            }
                        }
                    });
            }
            // // 花瓣网
            // convertSrc("https://hbimg.huabanimg.com/f4d9c3b860b9892539e7e13a98c8ee7fdfbc76e526114-shEkz9_fw236");
            // convertSrc("http://hbimg.huabanimg.com/cb59d728f570e47658c1626def91138e9a89e2fb2dc4f-3bfBGz_/fw/480");

            // // Dribbble
            // convertSrc("https://cdn.dribbble.com/users/1312595/screenshots/6313063/opposites-final_teaser.png");
            // convertSrc("https://cdn.dribbble.com/users/1312595/screenshots/6313063/opposites-final_1x.png");
            // convertSrc("https://cdn.dribbble.com/users/1175294/screenshots/6314189/attachments/1352284/iphone_x___3.png");

            // // Pinterest
            // convertSrc("https://i-h2.pinimg.com/236x/a6/df/92/a6df9243374c69f192608b7abbf5574e.jpg");

            // // 新浪微博
            // convertSrc("https://wx4.sinaimg.cn/thumb180/677ce64bgy1g1xl0gubv8j21o02yo1kz.jpg");
            // convertSrc("https://ww1.sinaimg.cn/thumb180/706aa1d0ly1g1xhjqr4zlj20ox0z9goj.jpg");

            // // QQ 空间
            // convertSrc("https://b250.photo.store.qq.com/psb?/V10nBUtR3fziNP/ql5vW5WkFXpgGC5odAQ4aBlTOi7dChYNGslVOh.tS9s!/m/dCOwDZUbIAAAnull&bo=gAKAAgAAAAABByA!&rf=photolist&t=5");

            // // 豆瓣相册
            // convertSrc("https://img3.doubanio.com/view/photo/sqs/public/p2436488314.webp");
            // convertSrc("https://img3.doubanio.com/view/photo/m/public/p2436488314.webp");

            // // Flickr
            // convertSrc("https://live.staticflickr.com/4282/35329785312_dca631d5d5_n.jpg");
            // convertSrc("https://live.staticflickr.com/4282/35329785312_dca631d5d5_m.jpg");
            // convertSrc("https://live.staticflickr.com/4282/35329785312_dca631d5d5_s.jpg");

            // pocoimg
            // convertSrc("http://img1001.pocoimg.cn/image/yxy/yxy/07/2019/0222/11/15508067871860915_0_150.jpg");

            // 蘑菇街
            // convertSrc("https://s3.mogucdn.com/mlcdn/c45406/190219_46f5586ll1h8i2kg04cb2574j9cj9_640x960.jpg_100x100.jpg");
            // convertSrc("https://s3.mogucdn.com/mlcdn/c45406/190410_2fjd37ejbi7022ibc5i81i64156j0_1080x1620.jpg_100x999.v1c96.70.webp")
            // convertSrc("https://s11.mogucdn.com/mlcdn/c45406/190410_5i4ee1ljhehl32f27j3273849e39d_1080x1440.jpg_640x854.v1cAC.webp");
            // convertSrc("https://s11.mogucdn.com/mlcdn/c45406/190405_63i646gfhcbab4gbi784d5ej5gi05_930x1550.jpg_600x9999.v1c7E.webp");

            // 1688
            // convertSrc("https://cbu01.alicdn.com/img/ibank/2016/747/156/3317651747_592497378.60x60.jpg");

            // 淘宝
            // convertSrc("http://gd3.alicdn.com/imgextra/i3/0/TB1JSzTGFXXXXbAXpXXXXXXXXXX_!!0-item_pic.jpg_50x50.jpg_.webp");
            // convertSrc("https://gd4.alicdn.com/imgextra/i4/253257913/TB2xDM_XVXXXXXuXpXXXXXXXXXX_!!253257913.jpg_50x50.jpg");
            // convertSrc("http://img.alicdn.com/bao/uploaded/TB1nzsIHpXXXXacaXXXXXXXXXXX_!!0-item_pic.jpg_80x80.jpg");

            // 天猫
            // convertSrc("https://img.alicdn.com/imgextra/i2/2914266524/O1CN01h3zEQc1y42ROxrUWH_!!2914266524.jpg_60x60q90.jpg");

            // Houzz
            // convertSrc("https://st.hzcdn.com/simgs/0371ece805f8baf2_9-3038/traditional-prints-and-posters.jpg");
            // convertSrc("https://st.hzcdn.com/fimgs/317113c30bbb78bf_2373-w352-h295-b0-p0--contemporary-living-room.jpg")
            // convertSrc("https://st.hzcdn.com/simgs/0bf1a0700b1dd6c8_9-6534/contemporary-kitchen.jpg");

            // HouseBeautiful
            // convertSrc("https://hips.hearstapps.com/hmg-prod.s3.amazonaws.com/images/hero-shapeshifter-1528904754.jpg?crop=1.00xw:0.730xh;0,0.0924xh&resize=768:*");
            // convertSrc("https://hips.hearstapps.com/hmg-prod.s3.amazonaws.com/images/emily-henderson-portland-traditional-kitchen-second-round29-1541625540.jpg?crop=0.8085333333333333xw:1xh;center,top&resize=*:2685");

            // Officesnapshots
            // convertSrc("https://officesnapshots.com/wp-content/uploads/2018/10/kjellander-sjöberg-studio-stockholm-8-300x200.jpg");
            // convertSrc("https://officesnapshots.com/wp-content/uploads/2018/10/expensify-offices-portland-9-700x919.jpg");

            // Archilovers
            // convertSrc("https://img.archilovers.com/projects/c_383_4774b4d4-fd7d-4900-bf5c-8dc089d35c48.jpg");
            // convertSrc("https://img.archilovers.com/projects/e_150_bcdb963a-c15f-40b5-9349-826ffcfd7fba.jpg");
            // convertSrc("https://img.archilovers.com/projects/ff19f407-9a1e-42d8-9a84-648efc7ec02a.jpg?w=960&h=1265");

            // AD
            // convertSrc("https://media.architecturaldigest.com/photos/5c9d0bea8566f62fc3b57bd9/16:9/w_900/6_E.jpg");
            // convertSrc("https://media.architecturaldigest.com/photos/5c88132eef247e2d58f78906/2:1/w_1600/AD040119_GEHRY_02%2520copy.jpg");
            // convertSrc("https://media.architecturaldigest.com/photos/5c881346ef247e2d58f78908/master/w_1280%2Cc_limit/AD040119_GEHRY_06.jpg");

            // Archdaily
            // convertSrc("http://images.adsttc.com.qtlcn.com/media/images/5c63/5d12/284d/d10b/1e00/00d2/medium_jpg/-_Featured_image.jpg?1550015745");
            // convertSrc("http://images.adsttc.com.qtlcn.com/media/images/5cab/ffa6/284d/d1c3/9900/0062/thumb_jpg/Photo003_East_facade_of_the_Comprehensive_Gymnasium.jpg?1554775958");
            // convertSrc("http://images.adsttc.com.qtlcn.com/media/images/5c63/5d91/284d/d10b/1e00/00d5/thumb_jpg/08_2F_DSC1557-Edit.jpg?1550015873");
            // convertSrc("http://images.adsttc.com.qtlcn.com/media/images/5c63/5d7d/284d/d19e/3500/03ec/newsletter/07_2F_DSC1572-Edit_re.jpg?1550015855");

            // ArchDaily 国际版
            // convertSrc("https://images.adsttc.com/media/images/5ca4/b566/284d/d116/0c00/0263/medium_jpg/005.jpg?1554298174")
            // convertSrc("https://images.adsttc.com/media/images/5ca2/2dae/284d/d1aa/5100/0251/medium_jpg/14022019_-_Arq_Alonso_ph_G_Viramonte-3028-Editar.jpg?1554132390");
            // convertSrc("https://images.adsttc.com/media/images/5cab/f82c/284d/d1c3/9900/005c/newsletter/02_The_Shed_Photography_by_Iwan_Baan.jpg?1554774034");

            // Dezeen
            // convertSrc("https://static.dezeen.com/uploads/2019/04/milan-2019-matthew-day-jackson-kohlo_dezeen_sq-1704x1704.jpg");
            // convertSrc("https://static.dezeen.com/uploads/2019/04/foster-partners-melbourne-federation-square-apple-store-cancelled-sq_a-213x213.jpg");
            // convertSrc("https://static.dezeen.com/uploads/2019/04/milan-2019-matthew-day-jackson-kohlo_dezeen_2364_col_0.jpg");

            // Archiproducts
            // convertSrc("https://img.edilportale.com/news/69730_02.jpg");
            // convertSrc("https://img.edilportale.com/news/d_69730_02.jpg");
            // convertSrc("https://img.edilportale.com/product-thumbs/h_SELETTI-WEARS-TOILETPAPER-Stool-Seletti-385809-relf7b24f1e.jpg");
            // convertSrc("https://img.edilportale.com/product-thumbs/g_SELETTI-WEARS-TOILETPAPER-Stool-Seletti-385809-relf7b24f1e.jpg");
            // convertSrc("https://img.edilportale.com/product-thumbs/b_SELETTI-WEARS-TOILETPAPER-Stool-Seletti-385809-relf7b24f1e.jpg")

            // 500px
            // convertSrc("https://drscdn.500px.org/photo/301648997/q%3D80_h%3D450/v2?webp=true&sig=a1ba802a6dc58fac2830f68d5c024c1dd57fbfaabfbabb9d6758ffa0b8c02d2b");
            // convertSrc("https://drscdn.500px.org/photo/301648997/q%3D80_m%3D1000/v2?webp=true&sig=7b355fd2a95220789b58bc48604900f5e3e43782c46c7d4da8578beeb48f1387");
            // convertSrc("https://drscdn.500px.org/photo/301648997/q%3D80_h%3D300/v2?user_id=47867263&webp=true&sig=a14cfd59748f16441585b7b75e7e55e948d846f7948559cda12a0ed2f03ae2a0");
            // convertSrc("https://drscdn.500px.org/photo/301687603/q%3D80_m%3D1000/v2?user_id=47867263&webp=true&sig=7fbe0a06d932673d43b0cf110223261e7eafc6c2db16d036e45fb05bb9944ec5");

            // 站酷
            // convertSrc("https://img.zcool.cn/community/01a5ee5cada3aaa8012141684fefff.jpg@260w_195h_1c_1e_1o_100sh.jpg");
            // convertSrc("https://img.zcool.cn/community/01a5ee5cada3aaa8012141684fefff.jpg");
            // convertSrc("https://img.zcool.cn/community/018dc45cada30fa801208f8b6c381b.png@1280w_1l_0o_100sh.png");
            // convertSrc("https://img.zcool.cn/community/018dc45cada30fa801208f8b6c381b.png@0o.png");
            // convertSrc("https://img.zcool.cn/community/01b5965cad65f3a801208f8b9e8cfe.gif");
            // convertSrc("https://img.zcool.cn/community/0186b65cad63dda801208f8b8ba0ef.jpg@1280w_1l_2o_100sh.jpg");
            // convertSrc("https://img.zcool.cn/community/0186b65cad63dda801208f8b8ba0ef.jpg@2o.jpg");

            // interiordesign
            // convertSrc("https://d4qwptktddc5f.cloudfront.net/easy_thumbnails/thumbs_Interior-Design-Wutopia-Lab-Yu-Ting-Striped-House-Qinhuangdao-03.19.jpg.370x300_q60_crop-smart_upscale.jpg");
            // convertSrc("https://d4qwptktddc5f.cloudfront.net/Interior-Design-Wutopia-Lab-Yu-Ting-Striped-House-Qinhuangdao-03.19.jpg");

            // Medium
            // convertSrc("https://cdn-images-1.medium.com/max/2600/1*r2AuXvDuxdRWCqvmBhlssw.png");

            // Wordpress
            // convertSrc("https://techcrunch.com/wp-content/uploads/2016/02/shutterstock_147776027.jpg?w=990&crop=1");
            // convertSrc("https://techcrunch.com/wp-content/uploads/2019/04/GettyImages-668600565.jpg?w=430&h=230&crop=1");
            // convertSrc("https://www.capgemini.com/wp-content/uploads/2019/03/Reflect-IoD-BIM-for-Operators.jpg?w=540&h=304&crop=1");

            // Artstation
            // convertSrc("https://cdna.artstation.com/p/assets/covers/images/016/778/572/smaller_square/bikki-rajbhar-boil-me-textured-food-thumbnail.jpg?1553448737");
            // convertSrc("https://cdnb.artstation.com/p/assets/images/images/014/662/673/20181215144821/small_square/victor-quaresma-faun.jpg?1544906901");

            // convertSrc("https://cdn.ruguoapp.com/Fox98TNpeU3r5bTLgpuDaBuLv-a6.jpeg?imageMogr2/auto-orient/thumbnail/400x2000>/quality/70/interlace/1");
        });
}

function convertSrc(src) {
    if (src.indexOf("data:image") > -1) return src;
    if (cacheRules && cacheRules.rules) {
        for (let i = 0; i < cacheRules.rules.length; i++) {
            try {
                const rule = cacheRules.rules[i];
                var srcPattern = rule.srcPattern;
                var replaceRule = rule.replaceRule;
                var reg = RegExp(srcPattern);
                if (reg.test(src)) {
                    var newSrc;
                    var script = replaceRule.replace("'@'", 'src');
                    eval(`newSrc = ${script}`);
                    console.log(`${rule.site} > ${newSrc}`);
                    return newSrc;
                }
            }
            catch (err) {
                return src;
            }
        }
    }
    return src;
}

// 安装扩展后，自动将扩展需要的代码塞入所有的页面中，这样用户就不需要手动刷新了。
chrome.runtime.onInstalled.addListener(function () {
    console.log("onInstalled");
    chrome.tabs.query({}, function(tabs) {
        for (var i = 0; i < tabs.length; ++i) {
            if (tabs[i].url && tabs[i].url.indexOf("http") !== -1) {
                var url = tabs[i].url;
                if (!/^(?:http(s)?:\/\/)?[\w.-]+(?:\.[\w\.-]+)+[\w\-\._~:/?#[\]@!\$&'\(\)\*\+,;=.]+$/gm.test(url)) continue;
                if (url.indexOf("chrome.google.com/webstore") > -1) continue;
                chrome.tabs.insertCSS(tabs[i].id, { file: 'eagle-extension.css' });
                executeScripts(tabs[i].id, [ 
                    { file: "jquery.min.js" },
                    { file: "jquery-ui.min.js" },
                    { file: "mousetrap.min.js" },
                    { file: "extract-text.js" },
                    { file: "utils.js" },
                    { file: "content.js" }
                ]);
            }
        }
    });
});

function executeScripts(tabId, injectDetailsArray) {
    function createCallback(tabId, injectDetails, innerCallback) {
        return function () {
            chrome.tabs.executeScript(tabId, injectDetails, innerCallback);
        };
    }

    var callback = null;

    for (var i = injectDetailsArray.length - 1; i >= 0; --i)
        callback = createCallback(tabId, injectDetailsArray[i], callback);

    if (callback !== null)
        callback();   // execute outermost function
}